package com.rbevans;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 * Servlet implementation class ServletSession
 */
@WebServlet("/ServletSession")
public class ServletSession extends HttpServlet {
	private static final long serialVersionUID = 1L;
	private final static String KEY = "accessCount";
    /**
     * @see HttpServlet#HttpServlet()
     */
    public ServletSession() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		   response.setContentType("text/html;charset=UTF-8");
	        PrintWriter out = response.getWriter();
	        HttpSession session = request.getSession(true);
	        Integer accessCount = (Integer)session.getAttribute(KEY);
	        try {
	   
	            out.println("<html>");
	            out.println("<head>");
	            out.println("<title>Session Servlet</title>");  
	            out.println("</head>");
	            out.println("<body>");
	            if (accessCount == null) {
	                out.println("<h1>Welcome to the Session Servlet</h1>");
	                accessCount = new Integer(1);                
	            } else {
	                out.println("<h1>Welcome back to the Session Servlet</h1>");
	                accessCount = new Integer(accessCount.intValue() + 1);
	            }

	            out.println("Information on your session is as follows:");            
	            out.println("<table border=\"1\">");
	            out.println("<tr bgcolor=\"#FFAD00\">");
	            out.println("<th>Item</th><th>Value</th>");
	            out.println("</tr>");
	            out.println("<tr><td>Session ID</td><td>");
	            out.println(session.getId());
	            out.println("</td>");
	            out.println("<tr><td>Creation time</td><td>");
	            out.println(new Date(session.getCreationTime()));
	            out.println("</td>");
	            out.println("<tr><td>Time of last Access</td><td>");
	            out.println(new Date(session.getLastAccessedTime()));
	            out.println("</td>");
	            out.println("<tr><td>Times visited page this session</td><td>");
	            if (accessCount.intValue() == 1) {
	                out.println("First time visited!");
	            } else {
	                out.println(accessCount.toString());
	            }
	            out.println("</td>");
	            out.println("</table>");
	            out.println("</body>");
	            out.println("</html>");
	        } finally { 
	            if (out != null) {
	                out.close();
	            }
	        }
	        session.setAttribute(KEY, accessCount);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

		doGet(request, response);
	}

}
